mescc: Implement fflush, sscanf, vsscanf.
[mes.git] / build-aux / check-mescc.sh
1 #! /bin/sh
2
3 # Mes --- Maxwell Equations of Software
4 # Copyright © 2017,2018 Jan (janneke) Nieuwenhuizen <janneke@gnu.org>
5 #
6 # This file is part of Mes.
7 #
8 # Mes is free software; you can redistribute it and/or modify it
9 # under the terms of the GNU General Public License as published by
10 # the Free Software Foundation; either version 3 of the License, or (at
11 # your option) any later version.
12 #
13 # Mes is distributed in the hope that it will be useful, but
14 # WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with Mes.  If not, see <http://www.gnu.org/licenses/>.
20
21 if [ -n "$BUILD_DEBUG" ]; then
22     set -x
23 fi
24
25 export BLOOD_ELF GUILE HEX2 M1 MES MESCC
26 export M1FLAGS HEX2FLAGS PREPROCESS
27 export MES_ARENA MES_PREFIX MES_SEED
28 export BUILD_DEBUG
29 export LIBC CC32LIBS MESCCLIBS
30
31 MES=${MES-src/mes}
32 MESCC=${MESCC-scripts/mescc}
33 GUILE=${GUILE-guile}
34 MES_PREFIX=${MES_PREFIX-.}
35
36 HEX2=${HEX2-hex2}
37 M1=${M1-M1}
38 BLOOD_ELF=${BLOOD_ELF-blood-elf}
39 MES_SEED=${MES_SEED-../mes-seed}
40 MESCC=${MESCC-$(command -v mescc)}
41 [ -z "$MESCC" ] && MESCC=scripts/mescc
42 MES=${MES-$(command -v mes)}
43 [ -z "$MES" ] && MES=src/mes
44
45 if ! command -v $GUILE > /dev/null; then
46     GUILE=true
47 fi
48
49 tests="
50 t
51 00-exit-0
52 01-return-0
53 02-return-1
54 03-call
55 04-call-0
56 05-call-1
57 06-call-!1
58 10-if-0
59 11-if-1
60 12-if-==
61 13-if-!=
62 14-if-goto
63 15-if-!f
64 16-if-t
65 20-while
66 21-char[]
67 22-while-char[]
68 23-pointer
69 30-strlen
70 31-eputs
71 32-compare
72 33-and-or
73 34-pre-post
74 35-compare-char
75 36-compare-arithmetic
76 37-compare-assign
77 38-compare-call
78 40-if-else
79 41-?
80 42-goto-label
81 43-for-do-while
82 44-switch
83 45-void-call
84 46-function-static
85 47-function-expression
86 48-function-destruct
87 49-global-static
88 4a-char-array
89 50-assert
90 51-strcmp
91 52-itoa
92 53-strcpy
93 54-argv
94 60-math
95 61-array
96 62-array
97 63-struct-cell
98 64-make-cell
99 65-read
100 70-printf
101 71-struct-array
102 72-typedef-struct-def
103 73-union
104 74-multi-line-string
105 75-struct-union
106 76-pointer-arithmetic
107 77-pointer-assign
108 78-union-struct
109 79-int-array
110 7a-struct-char-array
111 7b-struct-int-array
112 7c-dynarray
113 7d-cast-char
114 7e-struct-array-access
115 7f-struct-pointer-arithmetic
116 7g-struct-byte-word-field
117 7h-struct-assign
118 7i-struct-struct
119 7j-strtoull
120 7k-for-each-elem
121 7l-struct-any-size-array
122 7m-struct-char-array-assign
123 7n-struct-struct-array
124 7o-struct-pre-post
125 7p-struct-cast
126 7q-bit-field
127 7r-sign-extend
128 7s-struct-short
129 80-setjmp
130 81-qsort
131 82-define
132 83-heterogenoous-init
133 84-struct-field-list
134 85-sizeof
135 86-strncpy
136 87-sscanf
137 "
138
139 broken="$broken
140 7s-struct-short
141 "
142
143 set +e
144 expect=$(echo $broken | wc -w)
145 pass=0
146 fail=0
147 total=0
148 for t in $tests; do
149     if [ -z "${t/[012][0-9]-*/}" ]; then
150         LIBC=c-mini
151         MESCCLIBS="-l c-mini"
152     elif [ -z "${t/8[0-9]-*/}" ]; then
153         LIBC=c+tcc
154         MESCCLIBS="-l c+tcc"
155     else
156         LIBC=c
157         MESCCLIBS=
158     fi
159     sh build-aux/test.sh "scaffold/tests/$t" &> scaffold/tests/"$t".log
160     r=$?
161     total=$((total+1))
162     if [ $r = 0 ]; then
163         echo $t: [OK]
164         pass=$((pass+1))
165     else
166         echo $t: [FAIL]
167         fail=$((fail+1))
168     fi
169 done
170
171 tests="
172 00_assignment
173 01_comment
174 02_printf
175 03_struct
176 04_for
177 05_array
178 06_case
179 07_function
180 08_while
181 09_do_while
182
183 10_pointer
184 11_precedence
185 12_hashdefine
186 13_integer_literals
187 14_if
188 15_recursion
189 16_nesting
190 17_enum
191 18_include
192 19_pointer_arithmetic
193
194 20_pointer_comparison
195 21_char_array
196 22_floating_point
197 23_type_coercion
198 24_math_library
199 25_quicksort
200 26_character_constants
201 27_sizeof
202 28_strings
203 29_array_address
204
205 30_hanoi
206 31_args
207 32_led
208 33_ternary_op
209 34_array_assignment
210 35_sizeof
211 36_array_initialisers
212 37_sprintf
213 38_multiple_array_index
214 39_typedef
215
216 40_stdio
217 41_hashif
218 42_function_pointer
219 43_void_param
220 44_scoped_declarations
221 45_empty_for
222 46_grep
223 47_switch_return
224 48_nested_break
225 49_bracket_evaluation
226
227 50_logical_second_arg
228 51_static
229 52_unnamed_enum
230 54_goto
231 55_lshift_type
232 "
233
234 broken="$broken
235 18_include
236
237 22_floating_point
238 23_type_coercion
239 24_math_library
240 26_character_constants
241 27_sizeof
242 28_strings
243
244 31_args
245 34_array_assignment
246 37_sprintf
247 39_typedef
248
249 40_stdio
250 42_function_pointer
251 46_grep
252 49_bracket_evaluation
253 55_lshift_type
254 "
255
256 #22_floating_point       ; float
257 #23_type_coercion        ; float
258 #24_math_library         ; float
259 #27_sizeof               ; float
260 #28_strings              ; TODO: strncpy strchr strrchr memset memcpy memcmp
261 #30_hanoi                ; fails with GCC
262 #34_array_assignment     ; fails with GCC
263 #37_sprintf              ; integer formatting unsupported
264 #39_typedef              ;unsupported: (decl (decl-spec-list (stor-spec (typedef)) (type-spec (typename "MyFunStruct"))) (init-declr-list (init-declr (ptr-declr (pointer) (ident "MoreFunThanEver")))))
265
266 #40_stdio                ; f* functions
267 #42_function_pointer     ; f* functions
268 #46_grep                 ; f* functions
269 #49_bracket_evaluation   ; float
270
271
272
273 expect=$(echo $broken | wc -w)
274 for t in $tests; do
275     if [ ! -f scaffold/tinycc/"$t.c" ]; then
276         echo ' [SKIP]'
277         continue;
278     fi
279     sh build-aux/test.sh "scaffold/tinycc/$t" &> scaffold/tinycc/"$t".log
280     r=$?
281     total=$((total+1))
282     if [ $r = 0 ]; then
283         echo $t: [OK]
284         pass=$((pass+1))
285     else
286         echo $t: [FAIL]
287         fail=$((fail+1))
288     fi
289 done
290 [ $expect != 0 ] && echo "expect: $expect"
291 [ $fail != 0 ] && echo "failed: $fail"
292 [ $fail -lt $expect ] && echo "solved: $(($expect - $fail))"
293 echo "passed: $pass"
294 echo "total:  $total"
295 if [ $fail != 0 -a $fail -gt $expect ]; then
296     echo FAILED: $fail/$total
297     exit 1
298 elif [ $fail != 0 ]; then
299     echo PASS: $pass/$total
300 else
301     echo PASS: $total
302 fi